<template>
    <div>
        <div class="alert alert-danger" role="alert" v-if="invalid">
            The given credentials already exist or is invalid.
        </div>

        <div class="card">
            <div class="card-header">
                Sign Up!
            </div>

            <div class="card-body">
                <form @submit.prevent="onSubmit()">
                    <div class="form-group row mb-2">
                        <label class="col-md-2 col-form-label"
                               for="userNameId">Username</label>
                        <div class="col-md-8">
                            <input class="form-control"
                                   id="userNameId"
                                   type="text"
                                   v-model="username"
                                   placeholder="Username (required)"
                                   :class="{'is-invalid': $v.username.$error}"/>
                            <span class="invalid-feedback">
                                <span v-if="!$v.username.required">
                                    Please enter your username.
                                </span>
                                <span v-if="!$v.username.minLen">
                                    The username must be longer than {{ $v.username.$params.minLen.min }} characters.
                                </span>
                             </span>
                        </div>
                    </div>

                    <div class="form-group row mb-2">
                        <label class="col-md-2 col-form-label"
                               for="email">Email</label>
                        <div class="col-md-8">
                            <input class="form-control"
                                   id="email"
                                   type="email"
                                   v-model="email"
                                   placeholder="Email (required)"
                                   :class="{'is-invalid': $v.email.$error}"/>
                            <span class="invalid-feedback">
                                <span v-if="!$v.email.required">
                                    Please enter your email.
                                </span>
                             </span>
                        </div>
                    </div>

                    <div class="form-group row mb-2">
                        <label class="col-md-2 col-form-label"
                               for="firstNameId">Name</label>
                        <div class="col-md-8">
                            <input class="form-control"
                                   id="firstNameId"
                                   type="text"
                                   v-model="fullName"
                                   placeholder="Name (required)"
                                   :class="{'is-invalid': $v.fullName.$error}"/>

                        </div>
                        <span class="invalid-feedback">
                                <span v-if="!$v.fullName.required">
                                    Please enter your name.
                                </span>
                             </span>
                    </div>


                    <div class="form-group row mb-2">
                        <label class="col-md-2 col-form-label"
                               for="password">Password</label>
                        <div class="col-md-8">
                            <input class="form-control"
                                   id="password"
                                   type="password"
                                   v-model="password"
                                   placeholder="Password (required)"
                                   :class="{'is-invalid': $v.password.$error}"/>
                            <span class="invalid-feedback">
                                <span v-if="!$v.password.required">
                                    Please enter your password.
                                </span>
                                <span v-if="!$v.password.minLen">
                                    The password must be longer than {{ $v.password.$params.minLen.min }} characters.
                                </span>
                             </span>
                        </div>
                    </div>

                    <div class="form-group row mb-2">
                        <div class="offset-md-2 col-md-4">
                            <button class="btn btn-primary mr-3"
                                    type="submit">
                                Sign up
                            </button>
                        </div>
                    </div>
                </form>
            </div>
        </div>
    </div>
</template>

<script>
    import {required, minLength} from 'vuelidate/lib/validators';
    import UserService from "../../services/user.service";

    export default {
        data() {
            return {
                username: '',
                email: '',
                fullName: '',
                password: '',
                invalid: false
            }
        },
        validations: {
            username: {
                required,
                minLen: minLength(5)
            },
            email: {
                required
            },
            fullName: {
                required
            },
            password: {
                required,
                minLen: minLength(3)
            }
        },
        methods: {
            onSubmit() {
                this.$v.$touch();
                const userData= {
                    username: this.username,
                    email: this.email,
                    name: this.fullName,
                    password: this.password
                };
                UserService.register(userData).subscribe(res => {
                    UserService.getCurrentUser(res.data.token).subscribe(response => {
                        this.$store.dispatch('login', {token: res.data.token, username: response.data.data.username});
                        this.$router.replace('/shop')
                    })
                }, err => {
                    console.log(err);
                    this.invalid = true;
                })
            }
        }
    }
</script>
